Subject: RE: [Patch 1/3] connect.c: add nonstopssh variant to the sshVariant set.

From: "Randall S. Becker" <[email-masked]>
Date: Sat, 5 Jun 2021 17:56:49 -0400

On June 4, 2021 4:35 PM, I wrote:
>To: 'Junio C Hamano' <[email-masked]>
>Cc: 'Git Mailing List' <[email-masked]>
>Subject: RE: [Patch 1/3] connect.c: add nonstopssh variant to the sshVariant set.
>
>On June 4, 2021 3:52 PM, Junio C Hamano wrote:
>>"Randall S. Becker" <[email-masked]> writes:
>>> The primary
>>> problem is supplying -S $ZSSH0 on the command line causes $ZSSH0 to
>>> be resolved as a shell variable. It is not.
>>
>>I think we've heard that one before, and the whole thing sounds like
>>you are saying that a command line
>>
>>    $ cmd $ZSSH0
>>
>>expects ZSSH0 to be a variable and tries to interpolate its value
>>before passing it to "cmd" while you want "cmd" to see a literal string that begins with a dollar sign.
>>
>>And the standard solution to that problem obviously is to tell the
>>shell that the dollar-sign is not a reference to a variable by quoting, by using any variant of e.g.
>>
>>    $ cmd \$ZSSH0
>>    $ cmd '$ZSSH0'
>>    $ cmd "\$ZSSH0"
>
>I'm going to have to retest this, but, when I last tried this, admittedly around git 2.0, what happened was that one level of
escaping the $
>worked for ls-remote, but we needed two levels for upload-pack which seemed to have two shells processing the command. I might be
>wrong about the specifics (been 4 years), but there was an inconsistency with the number of required escapes. The single quote did
not
>work for upload-pack at the time. It is entirely possible that the second level indirection happened because the execution of the
sshoss
>command itself cross over a platform boundary between the POSIX and non-POSIX file systems (it lives in the non-POSIX side).
>
>>As far as I can tell, the code in connect.c that spawns ssh via
>>GIT_SSH_COMMAND uses the pretty vanilla run_command() interface, and that ought to be capable of producing such a command line,
>so I am lost as to where the need to have special case comes from.
>
>>"cmd" here may be "ssh" but run_command() should not care what exact
>>command is being invoked.  I am puzzled why a simple quoting like the
>>following cannot be adjusted for this particular case, for
>>example:
>>
>>    $ cat >>.git/config <<\EOF
>>    [alias]
>>	cmdtest0 = "!echo ..\\$ZSSH0.."
>>	cmdtest1 = "!echo ..$ZSSH0.."
>>    EOF
>>    $ ZSSH0=foo git cmdtest0
>>    ..$ZSSH0..
>>    $ ZSSH0=foo git cmdtest1
>>    ..foo..
>
>The multi-level resolution that I experienced is not covered in this situation. Still going to investigate this. I'm working on a
different
>approach to extend my wrapper script to parse out the port, to supply to sshoss, which is not complaint with the standard ssh. If I
have to
>stick with that script, there's no point going further on this variant.

Without a variant (when simple is used), obviously ports cannot be specified. When using the following URL:

    git clone ssh://[email-masked]:22/myproj/repo.git repo

The arguments appended using the auto-detected ssh variant that end up being passed to the GIT_SSH_COMMAND command string are:

    -o SendEnv=GIT_PROTOCOL -p 22 [email-masked] git-upload-pack '/myproj/repo.git'

which is part of the way there, but the -o SendEnv=GIT_PROTOCOL is OpenSSH specific. There is no such argument for the SSHOSS
program. This becomes somewhat problematic.

Of course, a sufficiently smart wrapper can detect this and strip off the -o SendEnv, which I have working. This just does not seem
like a general solution, leading me back down the nonstopssh variant path.

Sigh.

Randall